local r=JM.Utils
local i={
smooth=1,
linear=2,
fast_smooth=3,
balanced=4,
strong_dash=5,
smooth_dash=6,
gaussian=7,
}
local d={
[i.smooth]=function(e)
if e>=math.pi then
return 1.
end
return(1.-(1.+math.cos(e))*.5)
end,
[i.linear]=function(e)
if e>1. then return 1. end
return e
end,
[i.fast_smooth]=function(e)
e=e-2.718281828459
local t=2.718281828459^(2.*e)
local t=(1.+(t-1.)/(t+1.))*.5
if e<2.718281828459 then
return t
else
return 1.
end
end,
[i.balanced]=function(e)
e=e-5.
local t=1./(1.+(2.718281828459^(-e)))
if e<5. then
return t
else
return 1.
end
end,
[i.strong_dash]=function(e)
local t=2.718281828459^(2.*e)
local t=((t-1.)/(t+1.))
if e<3. then
return t
else
return 1.
end
end,
[i.smooth_dash]=function(e)
if e>=math.pi*.5 then
return 1.
end
e=math.sin(e)
return e
end,
[i.gaussian]=function(e)
local t=2.718281828459^(-(e^2.))
if e<2.5 then
return 1.-t
else
return 1.
end
end
}
local w={
[i.smooth]=math.pi,
[i.linear]=1.,
[i.fast_smooth]=2.718281828459*2.,
[i.balanced]=10.,
[i.strong_dash]=3.,
[i.smooth_dash]=math.pi/2.,
[i.gaussian]=2.5,
}
local h={}
h.__index=h
do
function h:new(o,i,a,t)
local e=setmetatable({},h)
h.__constructor__(e,o,i,a,t)
return e
end
function h:__constructor__(t,e,o,a)
self.camera=o
self:refresh(t,e,a)
end
function h:refresh(t,e,o)
self.rx=t
self.ry=e
local a=self.camera
t=t-a.focus_x/a.scale
e=e-a.focus_y/a.scale
t=r:round(t)
e=r:round(e)
self.last_x=self.x or t
self.last_y=self.y or e
self.x=t
self.y=e
self.last_id=self.id or self.last_id
self.id=o
self.range_x=t-self.last_x
self.range_y=e-self.last_y
self.diff_x=t-a.x
self.diff_y=e-a.y
self.last_direction_x=self.direction_x~=0 and self.direction_x or self.last_direction_x or 1
self.last_direction_y=self.direction_y~=0 and self.direction_y or self.last_direction_y or 1
self.direction_x=(self.range_x>0 and 1)
or(self.range_x<0 and-1)or 0
self.direction_y=(self.range_y>0 and 1)
or(self.range_y<0 and-1)or 0
end
end
local n={
chasing=1,
on_target=2,
no_target=3,
deadzone=4,
}
local s={
normal=1,
dynamic=2,
chase_when_not_moving=3
}
local m={
[1]="chasing",
[2]="on_target",
[3]="no_target",
[4]="deadzone",
}
local function f(e,h)
local a=e.axis
local t=e.camera
local o=e.target
local u,c,l,d=t:get_viewport_in_world_coord()
do
local i,n=e.window_1,e.window_2
if i and n then
if n<i then i,n=n,i end
local s=a=="x"
local h=s and(u+l*i)or(c+d*i)
local n=s and(u+l*n)or(c+d*n)
local i=s and"rx"or"ry"
if o[i]<h then
local n=t[a]
t[a]=t[a]+(o[i]-h)
e.init_pos=e.init_pos+(t[a]-n)
elseif o[i]>n then
local s=t[a]
t[a]=t[a]+(o[i]-n)
e.init_pos=e.init_pos+(t[a]-s)
end
end
end
if e.type==s.chase_when_not_moving then
local i=a=="x"and"range_x"or"range_y"
if o[i]~=0 then
e.time=-e.delay
local i="set_focus_"..a
local n=(a=="x"and"viewport_w"or"viewport_h")
t[i](t,e.focus_1*t[n])
e.init_pos=t[a]
o:refresh(o.rx,o.ry)
return
end
end
if e.time<0 then
e.time=e.time+h
if e.time>0 then
e.time=0
e.init_pos=e.camera[a]
else
o:refresh(o.rx,o.ry)
return
end
end
e.time=e.time+(e.factor_domain/e.speed)*h
do
local t=e.get_factor
if t~=i.balanced
and t~=i.fast_smooth
and t~=i.strong_dash
and t~=i.gaussian
then
e.time=r:clamp(e.time,0,e.factor_domain)
end
end
local h=o[a]-e.init_pos
local i=o[a]>t[a]and 1 or 0
i=o[a]<t[a]and-1 or i
t[a]=e.init_pos+h*e.get_factor(e.time)
if e.type==s.dynamic then
if e:target_changed_direction()then
local i="viewport_"..(a=="x"and"w"or"h")
local s="direction_"..a
if e.focus_1<=e.focus_2 then
if o[s]<0 then
t["set_focus_"..a](t,t[i]*e.focus_2)
elseif o[s]>0 then
t["set_focus_"..a](t,t[i]*e.focus_1)
end
else
if o[s]<0 and o[a]>t[a]then
t["set_focus_"..a](t,t[i]*e.focus_2)
elseif o[s]>=0 and o[a]<t[a]then
t["set_focus_"..a](t,t[i]*e.focus_1)
end
end
t:keep_on_bounds()
return e:set_state(n.chasing,true)
end
e:check_and_fix_cam_focus()
elseif e.type==s.normal then
end
do
local o=a=="x"
local n=o and"bounds_left"or"bounds_top"
local i=o and"bounds_right"or"bounds_bottom"
local o=o and"viewport_w"or"viewport_h"
if t[a]<t[n]
or t[a]>t[i]-t[o]/t.scale
then
e.time=e.factor_domain
end
end
t:keep_on_bounds()
if(e.time>=e.factor_domain and e.target[a]==t[a])
or o[a]==t[a]
then
return e:set_state(n.on_target)
end
end
local function c(e,t)
local o=e.target
local a=e.type
local t=e.axis
if a==s.dynamic then
if e:target_changed_direction()then
if e:camera_hit_bounds()then
e:check_and_fix_cam_focus()
end
e:set_state(n.deadzone)
end
elseif a==s.normal then
if e.delay~=0 then
if e:target_changed_direction()
and not e:camera_hit_bounds()
then
e:set_state(n.chasing)
e.speed=1.5
return
end
end
elseif a==s.chase_when_not_moving then
local a="range_"..t
if o[a]<0 then
e:set_state(n.chasing)
e.speed=2.*(math.abs(o["diff_"..t])/e.camera.tile_size)
if e.speed<.9 then e.speed=.9 end
if e.speed>1.5 then e.speed=1.5 end
return
end
end
e.camera[t]=o[t]
e.camera:keep_on_bounds()
end
local function y(t,e)
local d=t.target
local e=t.camera
if t.type==s.dynamic then
local a=t.axis
local h=(a=="x"and"w"or"h")
local s="focus_"..a
local u="deadzone_"..h
local l="r"..a
local i=e[a]+e[s]/e.scale
i=i-e[u]/2
if d[l]<i then
local o=e["viewport_"..h]*t.focus_2
o=r:round(o)
t:set_state(n.chasing)
if e[s]~=o then
e["set_focus_"..a](e,o)
t.speed=1.5
else
t.speed=1
end
elseif d[l]>i+e[u]then
local o=e["viewport_"..h]*t.focus_1
o=r:round(o)
t:set_state(n.chasing)
if e[s]~=o then
e["set_focus_"..a](e,o)
t.speed=1.5
else
t.speed=1
end
end
end
end
local t={
Type=s,
State=n,
MoveTypes=i,
}
t.__index=t
function t:new(a,o)
local e=setmetatable({},t)
t.__constructor__(e,a,o)
return e
end
function t:__constructor__(o,t,e,a)
self.camera=o
self.target=nil
self.axis=t or"x"
self.focus_1=.5
self.focus_2=1-self.focus_1
self.delay=e or .0
self.delay=math.abs(self.delay)
self.window_1=.25
self.window_2=.6
if self.axis=="x"then
self.window_1=.1
self.window_2=.9
end
self.speed=10
self.type=a or s.normal
self:set_move_behavior()
self:set_state(n.no_target)
end
function t:set_target(t,a,e)
if not self.target then
self.target=h:new(t,a,self.camera,e)
self:set_state(n.chasing)
else
self.target:refresh(t,a,e)
end
end
function t:set_move_behavior(e)
e=e or i.smooth
if not d[e]then e=i.smooth end
self.behavior_type=e
self.get_factor=d[e]
self.factor_domain=w[e]
end
function t:set_type(e)
if e==self.type or not e then return false end
if type(e)=="string"then
return self:set_type(s[e:lower()])
end
self.type=e
local t=self.axis
local a="set_focus_"..t
local e=self.camera
local t=t=="x"and"viewport_w"or"viewport_h"
e[a](e,self.focus_1*e[t])
return true
end
function t:get_target_relative_position()
local t=self.axis
local e=self.target[t]
local t=self.camera[t]
if e>t then
return 1
elseif e<t then
return-1
else
return 0
end
end
function t:check_and_fix_cam_focus()
local e=self.camera
local t=self.axis
local n=self.target
local t=t=="x"
local o=t and"direction_x"or"direction_y"
local a=t and"set_focus_x"or"set_focus_y"
local i=t and"viewport_w"or"viewport_h"
local t=t and"focus_x"or"focus_y"
if self.focus_1<=self.focus_2 then
local s=r:round(self.focus_1*e[i])
if n[o]>0
and e[t]~=s
then
e[a](e,s)
return true
end
local i=r:round(self.focus_2*e[i])
if n[o]<0 and e[t]~=i then
e[a](e,i)
return true
end
end
return false
end
function t:camera_hit_bounds()
local a=self.axis
local e=self.camera
local t=a=="x"
local i=t and"bounds_left"or"bounds_top"
local o=t and"bounds_right"or"bounds_bottom"
local t=t and"viewport_w"or"viewport_h"
if e[a]<=e[i]
or e[a]>=e[o]-e[t]/e.scale
then
return true
end
return false
end
function t:target_changed_direction()
local e=self.target
if e then
local t=self.axis
local a="direction_"..t
local t="last_direction_"..t
if(e[a]==-1 and e[t]>0)
or(e[a]==1 and e[t]<0)
then
return true
end
end
return false
end
function t:skip_delay()
if not self.target then return end
if self.time and self.time<0 then self.time=0 end
end
function t:is_on_target()
if not self.target then return false end
local e=self.axis
local t=self.camera
return t[e]==self.target[e]
end
function t:reset()
self.state=nil
self.init_pos=nil
if not self.target then return end
self.target=nil
end
function t:set_state(e,t)
if(e==self.state and not t)
or not e
then
return false
end
self.state=e
local t=self.camera
if not self.target then return end
if e==n.chasing then
self.init_pos=t[self.axis]
self.init_dist=self.init_pos-self.target[self.axis=="x"and"rx"or"ry"]
self.time=-self.delay
self.speed=1.5
elseif e==n.on_target then
self.target:refresh(self.target.rx,self.target.ry)
elseif e==n.no_target then
elseif e==n.deadzone then
end
return true
end
function t:target_position_x()
if not self.target then return"error"end
local e=self.init_pos
if self.target.x<self.camera.x+self.camera.focus_x then return"right"end
if self.target.x<self.camera.x+self.camera.focus_x then return"left"end
return"equal"
end
function t:update(e)
local t=self.state
if not self.target then
return
end
if t==n.chasing then
f(self,e)
elseif t==n.on_target then
c(self,e)
elseif t==n.deadzone then
y(self,e)
end
self.camera:keep_on_bounds()
end
function t:draw()
do
return
end
local t=love.graphics.print
local e=self.camera
if self.axis=='y'and self.target then
self.tt=self.tt or-2.71
self.tt=self.tt+((2.71*2)/5.)*love.timer.getDelta()
t(d[4](self.time),e.x+10,e.y+20)
t("time: "..self.time,e.x+10,e.y+36)
t("diff_X: "..self.target.diff_y,e.x+10,e.y+52)
end
do
return
end
if self.target and self.axis=='x'then
love.graphics.setColor(0,0,0)
t(string.format("%.2f",self.time),e.x+10,e.y+10)
t(string.format("%.2f",1-(1+math.cos(self.time))/2),e.x+10,e.y+10+16)
t("State: "..m[self.state],e.x+10,e.y+26+16)
t("rx= "..self.target.rx,e.x+10,e.y+58+16)
t("x= "..self.target.x,e.x+10,e.y+74+16)
t("focus_x= "..self.camera.focus_x,e.x+10,e.y+90+16)
t("init_x= "..self.init_pos,e.x+10,e.y+106+16)
t("init_distx= "..self.init_dist,e.x+10,e.y+124+16)
t("cam_x= "..e.x,e.x+10,e.y+140+16)
t("trgt_dx= "..self.target.direction_x,e.x+10,e.y+156+16)
t("range="..self.target.range_y,e.x+10,e.y+188+16)
end
local e=self.camera
local t=love.graphics
do
return
end
if self.axis=="x"then
t.setColor(0,1,1,.6)
local a=e.x+(e.viewport_w/e.scale)*self.focus_1
t.line(a,e.y,a,e.y+e.viewport_h/e.scale)
t.setColor(1,1,0,.6)
local a=e.x+(e.viewport_w/e.scale)*self.focus_2
t.line(a,e.y,a,e.y+e.viewport_h/e.scale)
else
t.setColor(0,1,1,.6)
local a=e.y+(e.viewport_h/e.scale)*self.focus_1
t.line(e.x,a,e.x+e.viewport_w/e.scale,a)
t.setColor(1,0,1,.6)
a=e.y+(e.viewport_h/e.scale)*self.focus_2
t.line(e.x,a,e.x+e.viewport_w/e.scale,a)
end
end
return t
