local a=JM.Utils
local o=
"\nError: Trying to use a 'Effect' object without associate him to a 'Affectable' object.\n\nTip: Try use the ':apply' method from the 'Effect' object."
local function i(e)
if not e then return end
assert(e.__effect_manager,"\nError: The class do not have the required '__effect_manager' field.")
assert(e.set_color,"\nError: The class do not implements the required 'set_color' method.")
assert(e.set_visible,
"\nError: The class do not implements the required 'set_visible' method.")
assert(e.__draw__,
"\nError: The class do not implements the required '__draw__' method.")
assert(e.__get_effect_transform,
"\nError: The class do not implements the required '__get_effect_transform' method.")
end
local t={
generic=0,
flash=1,
flickering=2,
pulse=3,
colorFlick=4,
popin=5,
popout=6,
fadein=7,
fadeout=8,
ghost=9,
spin=10,
clockWise=11,
counterClockWise=12,
swing=13,
pop=14,
growth=15,
disc=16,
idle=17,
echo=18,
float=19,
pointing=20,
darken=21,
brighten=22,
shadow=23,
line=24,
zoomInOut=25,
stretchHorizontal=26,
stretchVertical=27,
circle=28,
eight=29,
bounce=30,
heartBeat=31,
butterfly=32,
jelly=33,
shake=34,
clickHere=35,
jump=36,
ufo=37,
pendulum=38,
earthquake=39,
ghostShader=40,
stretchSquash=41,
}
local e={}
e.__index=e
e.TYPE=t
function e:new(a,t)
local o=setmetatable({},e)
return e.__constructor__(o,a,t)
end
function e:__constructor__(o,t)
self.__id=e.TYPE.generic
self.__color=a:get_rgba(1,1,1,1)
self.__scale={x=1,y=1}
self.__is_enabled=true
self.__prior=1
self.__rad=0
self.cycle_count=0
self.__args=t
self.__remove=false
self.__update_time=0
self.__duration=t and t.duration or nil
self.__speed=.5
self.__max_sequence=t and t.max_sequence or 100
self.__ends_by_cycle=t and t.max_sequence or false
self.__time_delay=t and t.delay or 0
self.__type_transform={}
self.__remove=false
self.ox=nil
self.oy=nil
self.__obj_initial_color=a:get_rgba(1,1,1,1)
self:set_object(o)
return self
end
function e:set_final_action(e,t)
self.__final_action=e
self.__args_final_action=t
end
function e:init()
self.__remove=false
self.__is_enabled=true
self.__rad=0
self.cycle_count=0
self.__update_time=0
self.__not_restaure=false
self:__constructor__(self.__args)
end
function e:copy()
local e=e:new(nil,self.__args)
return e
end
function e:set_object(e)
i(e)
self.__object=e
if self.__object then
self.__obj_initial_color=self.__object:get_color()
end
end
function e:get_object()
return self.__object
end
function e:__increment_cycle()
self.cycle_count=self.cycle_count+1
end
function e:completed_cycle()
return self.__max_sequence
and self.__ends_by_cycle
and(self.cycle_count>=self.__max_sequence)
end
function e:update(e)
return false
end
function e:__update__(e)
assert(self.__object,"Error: Effect object is not associated with a Affectable object.")
if self.__time_delay>0 then
self.__is_enabled=false
self.__time_delay=self.__time_delay-e
if self.__time_delay<=0 then
self.__is_enabled=true
else
return
end
end
self.__update_time=self.__update_time+e
if self.__duration and self.__update_time>=self.__duration then
self.__remove=true
end
if self.__max_sequence
and self.__ends_by_cycle
and(self.cycle_count>=self.__max_sequence)then
self.__remove=true
end
if self.__remove then
if self.__final_action then
self.__final_action(self.__args_final_action)
end
self:restaure_object()
end
end
function e:restaure_object()
local t=self.__object
assert(t,o)
local a=self.__id
local e=e.TYPE
if a==e.flash
or a==e.fadein
or a==e.fadeout
or a==e.ghost
or a==e.flickering
then
t:set_color(self.__obj_initial_color)
end
if a==e.flickering
or a==e.popout
then
t:set_visible(true)
end
local e=self.__type_transform
t:set_effect_transform("rot",e.rot and 0)
t:set_effect_transform("sx",e.sx and 1)
t:set_effect_transform("sy",e.sy and 1)
t:set_effect_transform("ox",e.ox and 0)
t:set_effect_transform("oy",e.oy and 0)
t:set_effect_transform("kx",e.kx and 0)
t:set_effect_transform("ky",e.ky and 0)
end
function e:draw(...)
return
end
function e:apply(e,t)
if not e then return end
if e and e~=self.__object then
if self.__object then self:restaure_object()end
self.__obj_initial_color=e:get_color()
end
self:set_object(e)
self:restart(t)
end
function e:set_unique_id(e)
if not self.__UNIQUE_ID then
self.__UNIQUE_ID=e
end
end
function e:get_unique_id()
return self.__UNIQUE_ID
end
function e:restart(e)
if e then
self:init()
end
assert(self.__object,o)
self.__object.__effect_manager:__insert_effect(self)
end
return e
