local a=require((...):gsub("Flash","Effect"))
local s,o,i=math.sin,math.pi,love.graphics.setShader
local n=[[
    extern vec4 flash_color;

    vec3 rgb2hsv(vec3 c){
        vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
        vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
        vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

        float d = q.x - min(q.w, q.y);
        float e = 1.0e-10;
        return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
    }

    vec3 hsv2rgb(vec3 c){
        vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
        vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
        return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
    }

    vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords){
        vec4 pixel = Texel(texture, texture_coords );
        vec3 hsv_pix = rgb2hsv(vec3(pixel.r, pixel.g, pixel.b));
        vec3 hsv_flash = rgb2hsv(vec3(flash_color.r, flash_color.g, flash_color.b));

        hsv_pix[2] = hsv_pix[2];

        vec3 result = vec3(
            hsv_flash[0],
            hsv_flash[1],
            hsv_flash[2]
        );

        result = hsv2rgb(result);

        return vec4(pixel.r + (flash_color.r * flash_color.a) ,
            pixel.g + (flash_color.g * flash_color.a) ,
            pixel.b + (flash_color.b * flash_color.a)  ,
            flash_color.a * pixel.a);
    }
  ]]
local t
local e=setmetatable({},a)
e.__index=e
function e:new(i,o)
t=t or love.graphics.newShader(n)
local t=a:new(i,o)
setmetatable(t,self)
e.__constructor__(t,o)
return t
end
function e:__constructor__(e)
self.__id=a.TYPE.flash
self.__alpha=1
self.__speed=e and e.speed or .3
self.__color=e and e.color or{238/255,243/255,46/255,1}
local t=e and e.max or 1
local e=e and e.min or .1
self.__origin=e
self.__range=(t-e)
self.__speed=self.__speed+self.__range*self.__speed
end
function e:update(e)
self.__rad=(self.__rad+o*2/self.__speed*e)
if self.__rad>=o then
self.__rad=self.__rad%o
self:__increment_cycle()
end
self.__color[4]=self.__origin+(s(self.__rad)*self.__range)
end
function e:draw(e,...)
i(t)
t:sendColor("flash_color",self.__color)
if(...)then
self.__object:__draw__(e,unpack{...})
else
self.__object:__draw__(e)
end
i()
end
return e
