local s=love.graphics.getScissor
local i=love.graphics.setScissor
local n=love.graphics.setColor
local o=love.graphics.rectangle
local a=require((...):gsub("container","component"))
local t={
normal=1,
left=2,
right=3,
center=4,
top=5,
bottom=6
}
local e=setmetatable({},a)
e.__index=e
e.INSERT_MODE=t
function e:new(t)
local e=a:new(t)
self.__index=self
setmetatable(e,self)
return e:__constructor__(t)
end
function e:__constructor__(e)
e=e or{}
self.components={}
self.N=0
self.space_vertical=e.space_vertical
self.space_horizontal=e.space_horizontal
self.border_x=e.border_x or 0
self.border_y=e.border_y or 0
self.type=self.TYPE.container
self.cur_gc=nil
self.num=0
self.show_bounds=e.show_bounds
self.skip_scissor=e.skip_scissor
self:set_type(e.type or"",e.mode or"center",e.grid_x,e.grid_y)
return self
end
function e:set_position(t,e)
t=t or self.x
e=e or self.y
local i,o=t-self.x,e-self.y
a.set_position(self,t,e)
self:shift_objects(i,o)
end
function e:shift_objects(e,a)
e=e or 0
a=a or 0
for t=1,self.N do
local t=self.components[t]
t:set_position(t.x+e,t.y+a)
end
end
function e:switch(t)
local e=self.cur_gc
self.num=t or 1
self.cur_gc=self.components[self.num]
if e then
e:set_focus(false)
end
if self.cur_gc then
self.cur_gc:set_focus(true)
end
end
function e:switch_to_obj(a)
local t=self.components
for e=1,self.N do
if t[e]==a then
return self:switch(e)
end
end
end
function e:switch_up()
self.num=self.num-1
if self.num<=0 then
self.num=self.N
end
return self:switch(self.num)
end
function e:switch_down()
self.num=self.num+1
if self.num>self.N then
self.num=1
end
return self:switch(self.num)
end
function e:switch_left()
return self:switch_up()
end
function e:switch_right()
return self:switch_down()
end
function e:get_obj_at(e)
return self.components[e]
end
function e:get_cur_obj()
return self.components[self.num]
end
function e:update(a)
for t=self.N,1,-1 do
local e=self.components[t]
if e.__remove then
table.remove(self.components,t)
self.N=self.N-1
else
local e=e.is_enable and e:update(a)
end
end
end
function e:mousepressed(o,a,t,i,n)
for e=1,self.N do
local e=self.components[e]
local e=e.is_enable and not e.__remove
and e:mousepressed(o,a,t,i,n)
end
end
function e:mousereleased(a,t,n,o,i)
for e=1,self.N do
local e=self.components[e]
local e=e.is_enable and not e.__remove
and e:mousereleased(a,t,n,o,i)
end
end
function e:keypressed(o,a,t)
for e=1,self.N do
local e=self.components[e]
local e=e.is_enable and not e.__remove
and e:keypressed(o,a,t)
end
end
function e:keyreleased(t,a)
for e=1,self.N do
local e=self.components[e]
local e=e.is_enable and not e.__remove
and e:keyreleased(t,a)
end
end
function e:draw(e)
local r,h,s,a=s()
if not self.skip_scissor and e and e.scene then
local e,a,t,o=e:scissor_transform(self.x,self.y,self.w,self.h,e.scene.subpixel)
i(e,a,t,o)
end
for e=1,self.N do
local e=self.components[e]
local t=e.right<self.x-20
or e.x>self.right+20
or e.bottom<self.y-20
or e.y>self.bottom+20
local e=e.is_visible and not e.__remove and not t
and e:draw()
end
i(r,h,s,a)
if self.show_bounds then
n(1,0,0,1)
o("line",self:rect())
n(0,1,1,1)
o("line",self.x+self.border_x,self.y+self.border_y,self.w-self.border_x*2,
self.h-self.border_y*2)
end
end
function e:add(e)
self.total_width=self.total_width or 0
self.total_height=self.total_height or 0
self.total_width=self.total_width+e.w
self.total_height=self.total_height+e.h
e:set_holder(self)
table.insert(self.components,e)
self.N=self.N+1
self:__add_behavior__()
if not self.cur_gc then
self:switch(1)
end
return e
end
function e:set_type(a,e,o,i)
e=t[e]
e=e or t.center
if a=="horizontal_list"then
self.__add_behavior__=function(t)
t:refresh_positions_x(e)
end
elseif a=="vertical_list"then
self.__add_behavior__=function(t)
t:refresh_positions_y(e)
end
elseif a=="grid"then
self.__add_behavior__=function(e)
e:refresh_pos_grid(i,o)
end
else
self.__add_behavior__=function()
end
end
end
function e:refresh_positions_y(o)
local e=self.N
if e<=0 then return end
local n=self.x+self.border_x
local s=self.y+self.border_y
local r=self.w-self.border_x*2
local a=self.h-self.border_y*2
local h=self.space_vertical
or((a-self.total_height)/(e-1))
for e=1,e do
local i=self.components[e-1]
local a=self.components[e]
local e=a.x
if o==t.left then
e=n
elseif o==t.right then
e=n+r-a.w
elseif o==t.center then
e=self.x+self.border_x
+(self.w-self.border_x*2)/2
-a.w/2
end
a:set_position(
e,
i and i.bottom+h or s
)
end
end
function e:refresh_positions_x(i)
local e=self.N
if e<=0 then return end
local h=self.x+self.border_x
local o=self.y+self.border_y
local a=self.w-self.border_x*2
local s=self.h-self.border_y*2
local r=(a-self.total_width)/(e-1)
for e=1,e do
local n=self.components[e-1]
local e=self.components[e]
local a=e.y
if i==t.center then
a=o+s/2-e.h/2
elseif i==t.top then
a=o
elseif i==t.bottom then
a=o+s-e.h
end
e:set_position(
n and n.right+r or h,
a
)
end
end
function e:refresh_pos_grid(t,e)
local a=self.N
if a<=0 then return end
t,e=t or 3,e or 2
assert(a<=t*e,"\n>>Error: Many components added to container.")
local s=self.x+self.border_x
local n=self.y+self.border_y
local o=self.w-self.border_x*2
local a=self.h-self.border_y*2
local o=o/e
local a=a/t
for i=1,t do
for t=1,e do
local e=self.components[e*(i-1)+t]
if e then
local i=n+(i-1)*a
local t=s+(t-1)*o
e:set_position(
t+o/2-e.w/2,
i+a/2-e.h/2
)
else
return
end
end
end
end
return e
