local a=require(string.gsub(...,"stick","component"))
local d=_G.JM_Utils
local n,r,h=math.abs,math.sin,math.cos
local l,s=math.atan2,math.sqrt
local t=love.graphics
local e=setmetatable({},a)
e.__index=e
function e:new(t)
t=t or{}
t.x=t.x or 250
t.y=t.y or 250
t.w=t.w or(96*1.3)
t.h=t.h or t.w or(96*1.3)
local a=a:new(t)
setmetatable(a,self)
e.__constructor__(a,t)
return a
end
function e:__constructor__(e)
self.radius=self.w/2
self.max_dist=self.radius*1.2
self.cx=self.x+self.w/2
self.cy=self.y+self.h/2
self.half_x=self.x+self.w/2
self.half_y=self.y+self.h/2
self.is_mobile=e.is_mobile
self.bounds_left=e.bound_left or 0
self.bounds_top=e.bound_top or 0
self.bounds_width=e.bound_width or(t.getWidth()*.25)
self.bounds_height=e.bound_height or t.getHeight()
self.init_x=self.x
self.init_y=self.y
self.opacity=e.opacity or 1
end
function e:set_position(o,e,t)
a.set_position(self,o,e)
self.cx=self.x+self.w*.5
self.cy=self.y+self.h*.5
self.half_x=self.x+self.w*.5
self.half_y=self.y+self.h*.5
if t then
self.init_x=self.x
self.init_y=self.y
end
end
function e:set_bounds(e,t,a,o)
self.bounds_left=e or self.bounds_left
self.bounds_top=t or self.bounds_top
self.bounds_width=a or self.bounds_width
self.bounds_height=o or self.bounds_height
end
function e:grow()
self:set_effect_transform("sx",1.2)
self:set_effect_transform("sy",1.2)
end
function e:shrink()
self:set_effect_transform("sx",1)
self:set_effect_transform("sy",1)
end
function e:mousepressed(t,e,r,h,o)
if self.is_mobile then
local a=a.collision(t,e,0,0,
self.bounds_left,self.bounds_top,
self.bounds_width,self.bounds_height
)
if a then
self:set_position(t-self.w/2,e-self.h/2)
end
end
local i=t-(self.half_x)
local n=e-(self.half_y)
local i=s(i^2+n^2)
if i<=self.radius then
a.mousepressed(self,t,e,r,h,o)
if self:is_pressed()then
self:grow()
end
end
end
function e:mousereleased(e,t,i,o,n)
if self:is_pressed()then
self:release()
end
a.mousereleased(self,e,t,i,o,n)
end
function e:touchpressed(r,e,t,h,n,s)
if self.__touch_pressed then return false end
if self.is_mobile then
local a=a.collision(e,t,0,0,
self.bounds_left,self.bounds_top,
self.bounds_width,self.bounds_height
)
if a then
self:set_position(e-self.w/2,t-self.h/2)
end
end
local i=e-(self.x+self.w/2)
local o=t-(self.y+self.h/2)
local o=math.sqrt(i^2+o^2)
if o<=self.radius then
a.touchpressed(self,r,e,t,h,n,s)
if self:is_pressed()then self:grow()end
end
end
function e:touchreleased(e,n,s,i,o,t)
if e~=self.__touch_pressed then return false end
if self:is_pressed()then
self:release()
end
a.touchreleased(self,e,n,s,i,o,t)
end
function e:release()
self:shrink()
self:set_position(self.init_x,self.init_y)
self.cx=self.half_x
self.cy=self.half_y
self.__mouse_pressed=false
self.__touch_pressed=false
self.angle=0
self.dist=0
end
function e:is_pressed()
return self.__mouse_pressed or self.__touch_pressed
end
function e:is_pressing(t,i,e)
i=i or .2
e=e or 50
local a,o=self:get_direction()
if a==0 and o==0 or not self.dist or not self.angle then
return false
end
local s=self:get_angle2()
if t=="left"or t=="right"then
if n(a)<i then return false end
local o=n(s)
if(t=="right"and o>e)or
(t=="left"and o<180-e)
then
return false
end
return(t=="left"and a<0)or(t=="right"and a>0)
else
if n(o)<i then return false end
e=e*1.25
local a=n(s)
if(t=="up"and(a>90+e
or a<90-e))
or(t=="down"and(a>90+e
or a<90-e))
then
return false
end
return(t=="up"and o<0)
or(t=="down"and o>0)
end
end
function e:get_direction()
if not self.angle or not self.dist
or(self.cx==self.half_x and self.cy==self.half_y)
then
return 0,0
end
local e=self.dist/self.max_dist
return e*(h(self.angle)>0 and 1 or-1),e*(r(self.angle)>0 and 1 or-1)
end
function e:get_angle()
return self.angle or 0
end
function e:get_angle2()
local e=self.angle or 0
e=e*180./math.pi
return e
end
function e:update(e)
a.update(self,e)
local e,t=love.mouse.getPosition()
if self:touch_is_active()then
e,t=love.touch.getPosition(self.__touch_pressed)
elseif self.__touch_pressed then
self:release()
end
if self.__mouse_pressed and not love.mouse.isDown(1)then
self:release()
end
if self:is_pressed()then
local e=e-self.half_x
local a=t-self.half_y
local t=l(a,e)
local e=s(e^2+a^2)
e=d:clamp(e,0,self.max_dist)
self.cx=self.half_x+e*h(t)
self.cy=self.half_y+e*r(t)
self.angle=t
self.dist=e
end
end
function e:__custom_draw__()
t.setColor(0,0,0,.4*self.opacity)
t.circle("fill",self.x+self.w/2,self.y+self.h/2,self.radius)
t.setColor(1,1,1,self.opacity)
t.circle("line",self.x+self.w/2,self.y+self.h/2,self.radius)
end
function e:draw()
a.draw(self)
t.setColor(1,1,1,self.opacity)
t.circle("fill",self.cx,self.cy,self.radius*.7)
t.setColor(.3,.3,.3,.2)
local e=self.radius*.7*.6
t.circle("fill",self.cx,self.cy,e)
t.setColor(0,0,0,.4*self.opacity)
t.circle("fill",self.cx-e-3,self.cy,4)
t.circle("fill",self.cx,self.cy-e-3,4)
t.circle("fill",self.cx+e+3,self.cy,4)
t.circle("fill",self.cx,self.cy+e+3,4)
end
return e
