local e=require"jm-love2d-package.init"
local t=love.graphics
function love.load()
math.randomseed(os.time())
t.setBackgroundColor(.1,.1,.1,1)
t.setDefaultFilter("nearest","nearest")
t.setLineStyle("rough")
love.mouse.setVisible(false)
_G.SCREEN_WIDTH=e.Utils:round(320)
_G.SCREEN_HEIGHT=e.Utils:round(180)
_G.WEB=false
_G.SUBPIXEL=4
_G.TILE=16
_G.CANVAS_FILTER="linear"
_G.TARGET=love.system.getOS()
if WEB then
e.Sound:set_song_mode("static")
end
require"data"
_G.FONT_THALEAH=e.FontGenerator:new_by_ttf{
name="thaleah",
dir="data/font/ThaleahFat.ttf",
dpi=16,
character_space=1,
word_space=3,
line_space=8,
min_filter='linear',
max_filter='nearest',
max_texturesize=2048,
}
FONT_THALEAH:set_font_size(FONT_THALEAH.__ref_height)
FONT_THALEAH:set_color(JM_Utils:get_rgba(JM_Utils:hex_to_rgba_float("242833")))
_G.RESIZE=function(t,o,i)
local a=.02
if not t.shader then
a=0
end
t.x=math.floor(o*a)
t.w=o-t.x
t.y=math.floor(o*a)
t.h=i-t.y
end
e:get_font():set_font_size(8)
e.esc_to_quit=false
local t=e.ControllerManager.P1
local a=t.Button
t.button_to_key[t.Button.A]={'space'}
t.button_to_key[t.Button.X]={'f','e','j'}
t.button_to_key[t.Button.B]={'escape','backspace'}
t.button_to_key[t.Button.R]={'f','rshift'}
t.button_to_key[t.Button.L]={'f','lshift'}
local t=e.ControllerManager.P2
t.button_to_key[a.A]={'i'}
t.button_to_key[a.X]={'u'}
do
local e=require"jm-love2d-package.modules.font.Word"
e.eff_wave_range=.75
e.eff_scream_range_y=1
e.eff_spooky_range_y=.4
end
e.Scene.set_default_scene_config(function(t)
if t.is_splash_screen
or _G.WEB
then
return
end
if SAVE_DATA.skip_crt then
t:set_shader()
return
end
do
local a=e.Shader:get_shader("crt_scanline",t,{
screen_h=288,
width=1,
})
a:send("opacity",.1)
local o=e.Shader:get_shader("aberration",t,{aberration_x=.1,aberration_y=.15})
local i=e.Shader:get_shader("filmgrain",t,{opacity=.3})
local e={}
t:set_shader({o,i,a},
function(o,a,t)
if t==2 then
e[1]=love.math.random()
e[2]=love.math.random()
a:send("noise",e)
end
end)
end
end)
return e:load_initial_state("lib.gamestate.title",true)
end
function love.textinput(t)
return e:textinput(t)
end
function love.keypressed(a,t,o)
if a=='p'and love.keyboard.isDown('lctrl')then
return love.graphics.captureScreenshot("img_"..os.time()..".png")
end
if _G.WEB and t=='f11'then
return
end
if not _G.WEB and t=='f10'then
SAVE_DATA.skip_crt=not SAVE_DATA.skip_crt
local t=e.SceneManager.scene
if t then
e.Scene.default_config(t)
t:resize(love.graphics:getDimensions())
SAVE_DATA:save_to_disc()
end
return
end
return e:keypressed(a,t,o)
end
function love.keyreleased(a,t)
return e:keyreleased(a,t)
end
function love.mousepressed(a,t,o,n,i)
return e:mousepressed(a,t,o,n,i)
end
function love.mousereleased(a,t,i,o,n)
return e:mousereleased(a,t,i,o,n)
end
function love.mousemoved(o,i,n,t,a)
return e:mousemoved(o,i,n,t,a)
end
function love.focus(t)
return e:focus(t)
end
function love.visible(t)
return e:visible(t)
end
function love.wheelmoved(a,t)
return e:wheelmoved(a,t)
end
function love.touchpressed(a,s,n,o,i,t)
return e:touchpressed(a,s,n,o,i,t)
end
function love.touchreleased(s,a,o,n,i,t)
return e:touchreleased(s,a,o,n,i,t)
end
function love.touchmoved(s,n,i,t,a,o)
return e:touchmoved(s,n,i,t,a,o)
end
function love.joystickpressed(t,a)
return e:joystickpressed(t,a)
end
function love.joystickreleased(t,a)
return e:joystickreleased(t,a)
end
function love.joystickaxis(a,t,o)
return e:joystickaxis(a,t,o)
end
function love.joystickadded(t)
return e:joystickadded(t)
end
function love.joystickremoved(t)
return e:joystickremoved(t)
end
function love.gamepadpressed(a,t)
return e:gamepadpressed(a,t)
end
function love.gamepadreleased(a,t)
return e:gamepadreleased(a,t)
end
function love.gamepadaxis(o,a,t)
return e:gamepadaxis(o,a,t)
end
function love.resize(t,a)
return e:resize(t,a)
end
function love.quit()
local e=SAVE_DATA:get_thread()
local e=e and e:wait()
end
local o=0
local a=1/30
function love.update(t)
o=collectgarbage("count")/1024.
t=t>a and a or t
SAVE_DATA:update(t)
return e:update(t)
end
function love.draw()
e:draw()
do
end
end
